"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var google_common_1 = require("./google.common");
var user_1 = require("./user");
var Google = (function (_super) {
    __extends(Google, _super);
    function Google() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Google.prototype.initialize = function () {
        this.manager = GIDSignIn.sharedInstance().init();
        this.manager.clientID = this.id;
        this.manager.serverClientID = this.serverId;
        this.manager.shouldFetchBasicProfile = this.fields;
        this.manager.scopes = NSArray.arrayWithArray(this.scopes);
        this.initializeUser();
        this._localDelegate = this.manager.delegate;
    };
    Google.prototype.login = function () {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this.errorCallback = function (error) { return reject(error); };
            _this.loginCallback = function (user) { return resolve(new user_1.default(user, 'google')); };
            _this.manager.signIn();
        });
    };
    Google.prototype.logout = function () {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this.errorCallback = function (error) { return reject(error); };
            _this.logoutCallback = function (value) { return resolve(value); };
            _this.manager.disconnect();
        });
    };
    Google.prototype.getCurrentToken = function () {
        return this.manager.currentUser
            ? this.manager.currentUser.authentication.accessToken
            : null;
    };
    Google.prototype.getCurrentUser = function () {
        var _this = this;
        return new Promise(function (resolve) {
            resolve(new user_1.default(_this.manager.currentUser, 'google'));
        });
    };
    return Google;
}(google_common_1.Google));
exports.Google = Google;
//# sourceMappingURL=google.ios.js.map