"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var login_button_common_1 = require("./login-button.common");
var authentication_1 = require("./../authentication");
var FacebookLoginButton = (function (_super) {
    __extends(FacebookLoginButton, _super);
    function FacebookLoginButton() {
        var _this = _super.call(this) || this;
        _this.isPassThroughParentEnabled = true;
        _this.nativeView = new FBSDKLoginButton();
        _this._localDelegate = FacebookLoginButtonDelegate.new();
        var facebook = authentication_1.FacebookInstance();
        facebook.loginUICallback = _this.notifyLogin.bind(_this);
        facebook.logoutUICallback = _this.notifyLogout.bind(_this);
        facebook.errorUICallback = _this.notifyError.bind(_this);
        return _this;
    }
    FacebookLoginButton.prototype.onLoaded = function () {
        _super.prototype.onLoaded.call(this);
        this.nativeView.delegate = this._localDelegate;
    };
    FacebookLoginButton.prototype.onUnloaded = function () {
        _super.prototype.onUnloaded.call(this);
        this.nativeView.delegate = undefined;
    };
    return FacebookLoginButton;
}(login_button_common_1.LoginButton));
exports.FacebookLoginButton = FacebookLoginButton;
var FacebookLoginButtonDelegate = (function (_super) {
    __extends(FacebookLoginButtonDelegate, _super);
    function FacebookLoginButtonDelegate() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    FacebookLoginButtonDelegate.prototype.loginButtonDidCompleteWithResultError = function (loginButton, result, error) {
        var facebook = authentication_1.FacebookInstance();
        if (error) {
            facebook.errorUICallback(error);
        }
        else if (!result || !result.token) {
            facebook.errorUICallback('Invalid token.');
        }
        else {
            facebook
                .fetchUser(result.token.tokenString)
                .then(function (user) { return facebook.loginUICallback(user); });
        }
    };
    FacebookLoginButtonDelegate.prototype.loginButtonDidLogOut = function (loginButton) {
        var facebook = authentication_1.FacebookInstance();
        facebook.logoutUICallback();
    };
    FacebookLoginButtonDelegate.prototype.loginButtonWillLogin = function (loginButton) {
        return true;
    };
    FacebookLoginButtonDelegate.ObjCProtocols = [FBSDKLoginButtonDelegate];
    return FacebookLoginButtonDelegate;
}(NSObject));
//# sourceMappingURL=facebook-login-button.ios.js.map