"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var User = (function () {
    function User(data, provider) {
        if (provider === 'facebook') {
            this.setDataFromFacebook(data);
        }
        else if (provider === 'google') {
            this.setDataFromGoogle(data);
        }
    }
    User.prototype.setDataFromGoogle = function (data) {
        this.email = data.profile.email;
        this.firstname = data.profile.givenName;
        this.lastname = data.profile.familyName;
        this.picture = data.profile.imageURLWithDimension(100);
        this.token = data.serverAuthCode
            ? data.serverAuthCode
            : data.authentication.idToken;
        this.id = data.userID;
    };
    User.prototype.setDataFromFacebook = function (data) {
        this.token = data.token;
        this.email = this.getString(data, 'email');
        this.firstname = this.getString(data, 'first_name');
        this.lastname = this.getString(data, 'last_name');
        this.picture = this.getPictureURL(data) || null;
        this.id = this.getString(data, 'id');
    };
    User.prototype.getPictureURL = function (data) {
        var url;
        return ((url = this.getObject(data, 'picture')) &&
            (url = this.getObject(url, 'data')) &&
            (url = this.getString(url, 'url')));
    };
    User.prototype.getString = function (data, key) {
        return data[key];
    };
    User.prototype.getObject = function (data, key) {
        return data[key];
    };
    return User;
}());
exports.User = User;
//# sourceMappingURL=user.common.js.map